![logo](https://github.com/ckdckd145/statmanager-kr/blob/main/doc/logo.png?raw=true)

# statmanager-kr
### Open-source statistical package for Python based on the Pandas.    
### Python과 Pandas 사용자를 위한 오픈소스 통계 패키지
 
#

Especially for researchers, data scientists, psychologist, students, and anyone who interested in conducting hypothesis testing. The statmanager-kr aims to organize packages that are "convenient to use", "uncompliated to use", and "convenient to see results". The end goal** **of statmanager-kr is to be a <b>simple and useful package</b> that <b>can be used </b>by people <b>who don't know much about Python and Pandas</b>.  

Pandas를 사용하며, 가설 검증에 대해 관심을 갖는 연구원, 데이터분석가, 심리학자, 학생 등을 위합니다. statmanager-kr은 사용하기 쉽고, 사용이 복잡하지 않으며, 결과를 확인하기에 편리한 패키지 구성을 목표로 개발됩니다. statmanager-kr 개발의 최종 목표는 <b>Python과 Pandas를 잘 알지 못하는 사람</b>도 이용할 수 있는 <b>매우 간편하면서도 유용한 패키지를 만드는 것</b>입니다.  

Currently, <b><u>KOREAN</u></b> and <b><u>ENGLISH</u></b> are supported.   
현재 지원하는 언어 세팅은 <b><u>한글</u></b>과 <b><u>영어</u></b>입니다. 


## Documentaion
[한글 문서](https://cslee145.notion.site/cslee145/fd776d4f9a4f4c9db2cf1bbe60726971?v=3b2b237555fc4cd3a41a8da337d80c01)   
[English Documentation](https://cslee145.notion.site/60cbfcbc90614fe990e02ab8340630cc?v=4991650ae5ce4427a215d1043802f5c0&pvs=4)


## Notification :
Source codes are available in the [Github respository](https://github.com/ckdckd145/statmanager-kr)  
소스코드는 [깃헙 레포지토리](https://github.com/ckdckd145/statmanager-kr)에서 확인할 수 있습니다.  

For updates, please see [the notice in the documentation]((https://www.notion.so/cslee145/NOTICEs-4bb2177eeb0f412a81b8dbd3215058e6)) or the [Github release](https://github.com/ckdckd145/statmanager-kr/releases).  
업데이트 내역은 정식 문서 내 [공지사항](https://www.notion.so/cslee145/NOTICEs-4bb2177eeb0f412a81b8dbd3215058e6) 혹은 [Github release](https://github.com/ckdckd145/statmanager-kr/releases)에서 확인하시기 바랍니다.    

Please use [Github Discussion](https://github.com/ckdckd145/statmanager-kr/discussions) to let me know if you have any questions, bugs you encounter, suggestions, etc. Of course, you can also email the developer directly.   
궁금하신 점, 발생하는 버그, 제안 사항 등 모든 것은 [Github Discussion](https://github.com/ckdckd145/statmanager-kr/discussions)을 활용해서 알려주시면 감사하겠습니다. 물론, 개발자에게 직접 이메일을 보내셔도 됩니다. 


#
* [Quick Start with sample jupyter notebook file](https://github.com/ckdckd145/statmanager-kr/blob/main/test.ipynb) 
* Available functions | 현재 사용 가능한 분석
  * [Read detailed instructions](https://www.notion.so/cslee145/Documentation-74a610c12881402d96dc5d1654f97433?pvs=4#be93db7f4159419fa73eb324d6567793)  | [상세 사용법 열람](https://www.notion.so/cslee145/dded43262f784c70a37fddb11ec7c9d1?pvs=4#ef9a4aacd8b34b96bd7a4abdea4f5170)****
    1. Normality assumption | 정규성 가정
    2. Homoskedasticity assumption | 등분산성 가정
    3. Reliability | 신뢰도 **확인**
    4. Frequency analysis  | 빈도분석
    5. Correlation analysis | 상관분석
    6. Comparison (2) | 차이비교 (2)
    7. Comparison (3) | 차이비교 (3)
    8. Regression


* Available functions to make figure or graph | 그래프 혹은 그림 제작에 활용되는 기능
  * P-P plot 
  * Q-Q plot 
  * Histogram 
  * Histogram (cumulative)
  * Pointplot (within differences)
  * Boxplot (between group difference)

#### Dependency
* pandas
* statsmodels
* scipy
* numpy
* matplotlib
* seaborn
* XlsxWriter

#### Recommendation
Using "Jupyter Notebook" is <b>STRONGLY RECOMMENDED</b> (Of course, statmanager-kr works just as well in a Python environment)   
"주피터 노트북(Jupyter Notebook)" 사용을 <b>강력하게 권고</b>합니다. 물론, Python 환경에서도 statmanager-kr은 문제없이 작동합니다.  

#### Installing statmanager-kr
    pip install statmanager-kr

#### Updating statmanager-kr
    pip install statmanager-kr --upgrade



# Development: Changseok Lee

<a href="https://www.github.com/ckdckd145" target="_blanck">
  <img src="https://img.shields.io/badge/Github-github?style=flat&logo=Github&color=black"
</a>
<a href="https://www.linkedin.com/in/cslee0052" target="_blank">
    <img src="https://img.shields.io/badge/LinkedIn%20Profile-kakao?style=flat&logo=LinkedIn&logoColor=white&color=black">
</a>
</a>
<a href="mailto:ckdckd145@gmail.com" target="_blank">
    <img src="https://img.shields.io/badge/Gmail-gmail?style=flat&logo=Gmail&logoColor=white&color=black">
</a>
</center>



#
### Copyright (C) 2023 Changseok Lee